/*
        Esimerkkiohjelma joka kytt VESA2-LFB:t ja vertaa
        muistin siirtonopeutta _farpokeb vs. _farpokel vs. _movedatal
*/

#include "vesa.h"
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/farptr.h>

#define SIZE 128000

char    buffer[SIZE*2];

void raster(void)
{
        outp(0x3c8,0);outp(0x3c9,63);outp(0x3c9,0);outp(0x3c9,0);
        while(!(inp(0x3da)&8))
                ;
        outp(0x3c8,0);outp(0x3c9,0);outp(0x3c9,0);outp(0x3c9,0);
}

int main(void)
{
        int     n,m,l,select,*tmp;

        /*      Nin helppoa tm on    */
        if((select=VBEeasymodel(320,400,8))==-1)
        {
                puts("Mode not found.");
                return(EXIT_FAILURE);
        }

        /*      Rhn bufferiin        */
        for(n=0;n<SIZE*2;n++)
                buffer[n]=n&15;

        /*      Skrollataan _farpokebilla       */
        l=0;
        while(!kbhit())
        {
                raster();

                for(n=0;n<SIZE;n++)
                        _farpokeb(select,n,buffer[n+l]);
                l++;
        }
        getch();

        /*      Skrollataan _farpokelilla (yllttvn nopea)    */
        l=0;
        while(!kbhit())
        {
                raster();

                tmp=(int *)&buffer[n+l];
                for(n=m=0;n<SIZE;n+=4,m++)
                        _farpokel(select,n,tmp[m]);
                l++;
        }
        getch();

        /*      Skrollataan _movedatalilla (nopein)     */
        l=0;
        while(!kbhit())
        {
                raster();

                _movedatal(_my_ds(),(int)&buffer[l],select,0,SIZE/4);
                l++;
        }
        getch();

        VBEfree(select);        /*      Selektori vapauteen.    */
        textmode(3);            /*      conio.h:ssa mritelty. Nppr. */
}
